package ch.psi.daq.queryrest.response;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonSubTypes.Type;
import com.fasterxml.jackson.annotation.JsonTypeInfo;

import ch.psi.daq.queryrest.response.csv.CSVHTTPResponse;
import ch.psi.daq.queryrest.response.json.JSONHTTPResponse;
import ch.psi.daq.queryrest.response.msgpack.MsgPackHTTPResponse;
import ch.psi.daq.queryrest.response.raw.event.RawEventHTTPResponse;
import ch.psi.daq.queryrest.response.smile.SmileHTTPResponse;

@JsonTypeInfo(
		use = JsonTypeInfo.Id.NAME,
		include = JsonTypeInfo.As.EXISTING_PROPERTY,
		property = "format")
@JsonSubTypes({
		@Type(value = JSONHTTPResponse.class, name = JSONHTTPResponse.FORMAT),
        @Type(value = MsgPackHTTPResponse.class, name = MsgPackHTTPResponse.FORMAT),
        @Type(value = SmileHTTPResponse.class, name = SmileHTTPResponse.FORMAT),
        @Type(value = CSVHTTPResponse.class, name = CSVHTTPResponse.FORMAT),
		@Type(value = RawEventHTTPResponse.class, name = RawEventHTTPResponse.FORMAT)
})
// see: http://stackoverflow.com/questions/24631923/alternative-to-jackson-jsonsubtypes
public abstract class PolymorphicResponseMixIn {
}
