package ch.psi.daq.queryrest.response;

import java.io.OutputStream;

import javax.servlet.ServletResponse;

public interface ResponseStreamWriter {

   /**
    * Responding with the the contents of the stream by writing into the output stream of the
    * {@link ServletResponse}.
    * 
    * @param <R> The JAVA result type
    * @param query The query
    * @param result The result
    * @param out The OutputStream
    * @param response The Response
    * @throws Exception thrown if writing to the output stream fails
    */
   public <R> void respond(
         final Object query, 
         final R result,
         final OutputStream out, 
         final AbstractHTTPResponse response) throws Exception;
}
