package ch.psi.daq.queryrest.response.csv;

import java.util.function.Function;

import ch.psi.daq.common.statistic.Statistics;
import ch.psi.daq.common.string.stringifier.Stringifier;
import ch.psi.daq.domain.DataEvent;
import ch.psi.daq.domain.query.operation.Aggregation;

public class AggregationStringifyer implements Function<DataEvent, String>, Stringifier {
   private final Aggregation aggregation;
   private final String nonValue;

   public AggregationStringifyer(final Aggregation aggregation, final String nonValue) {
      this.aggregation = aggregation;
      this.nonValue = nonValue;
   }

   @Override
   public String apply(final DataEvent event) {
      return toString(event);
   }

   @Override
   public String toString(final Object obj) {
      if (obj == null) {
         return nonValue;
      } else if (obj instanceof DataEvent) {
         return Double.toString(aggregation.getAccessor().applyAsDouble((DataEvent) obj));
      } else if (obj instanceof Statistics) {
         return Double.toString(aggregation.extractValue((Statistics) obj));
      } else {
         return String.valueOf(obj);
      }
   }
}
