package ch.psi.daq.queryrest.response.msgpack;

import org.msgpack.jackson.dataformat.MessagePackFactory;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.databind.ObjectMapper;

import ch.psi.daq.domain.backend.Backend;
import ch.psi.daq.domain.config.DomainConfig;
import ch.psi.daq.queryrest.config.QueryRestConfig;
import ch.psi.daq.queryrest.response.json.AbstractResponseStreamWriter;

public class MsgPackResponseStreamWriter extends AbstractResponseStreamWriter implements ApplicationContextAware {
   private ObjectMapper mapper;
   private MessagePackFactory factory;

   @Override
   public void setApplicationContext(ApplicationContext context) throws BeansException {
      final Backend backend = context.getBean(DomainConfig.BEAN_NAME_BACKEND_DEFAULT, Backend.class);
      context = backend.getApplicationContext();

      mapper = context.getBean(DomainConfig.BEAN_NAME_OBJECT_MAPPER, ObjectMapper.class);
      factory = context.getBean(QueryRestConfig.BEAN_NAME_MSG_PACK_FACTORY, MessagePackFactory.class);

      super.init(backend);
   }

   @Override
   protected JsonFactory getJsonFactory() {
      return factory;
   }

   @Override
   protected ObjectMapper getObjectMapper() {
      return mapper;
   }
}
