package ch.psi.daq.queryrest.response.raw.receive;

import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;

import ch.psi.daq.domain.json.BackendChannel;

public class Message<C, V> implements Serializable {
   private static final long serialVersionUID = 5975345475367745542L;
   private boolean configChanged = false;
   private C config = null;
   private Map<BackendChannel, V> values = new LinkedHashMap<>();

   public Message() {}

   public Message(final boolean configChanged, final C config, final Map<BackendChannel, V> values) {
      this.configChanged = configChanged;
      this.config = config;
      this.values = values;
   }

   public boolean isConfigChanged() {
      return configChanged;
   }

   public void setConfigChanged(final boolean configChanged) {
      this.configChanged = configChanged;
   }

   public C getConfig() {
      return config;
   }

   public void setValues(Map<BackendChannel, V> values) {
      this.values = values;
   }

   public Map<BackendChannel, V> getValues() {
      return values;
   }

   public void add(BackendChannel channel, V value) {
      this.values.put(channel, value);
   }
}
