package ch.psi.daq.queryrest.response.raw.receive;

import java.nio.ByteBuffer;
import java.util.function.IntFunction;

import com.fasterxml.jackson.databind.ObjectMapper;

public class ReceiverConfig<C, V> {

   private boolean parallelHandlerProcessing;
   private final MessageReader<C, V> messageReader;
   private IntFunction<ByteBuffer> allocator;

   private ObjectMapper objectMapper;

   public ReceiverConfig(MessageReader<C, V> messageReader) {
      this.messageReader = messageReader;
   }
   
   public boolean isParallelHandlerProcessing() {
      return parallelHandlerProcessing;
   }

   public void setParallelHandlerProcessing(boolean parallelHandlerProcessing) {
      this.parallelHandlerProcessing = parallelHandlerProcessing;
   }

   public MessageReader<C, V> getMessageReader() {
      return messageReader;
   }

   public IntFunction<ByteBuffer> getAllocator() {
      return allocator;
   }
   
   public void setAllocator(IntFunction<ByteBuffer> allocator) {
      this.allocator = allocator;
   }

   public ObjectMapper getObjectMapper() {
      return objectMapper;
   }

   public void setObjectMapper(ObjectMapper objectMapper) {
      this.objectMapper = objectMapper;

      addObjectMapperMixin(objectMapper);
   }

   public static void addObjectMapperMixin(ObjectMapper objectMapper) {}
}
