package ch.psi.daq.queryrest.response.raw.receive;

import java.util.Map;
import java.util.concurrent.atomic.AtomicBoolean;

import ch.psi.daq.domain.json.BackendChannel;

public class ReceiverStateImpl<C, V> implements ReceiverState<C, V> {
   private final AtomicBoolean isRunning;
   private long hash = Long.MIN_VALUE;
   private boolean hashChanged = false;
   private C config;
   private Message<C, V> message;

   public ReceiverStateImpl(AtomicBoolean isRunning) {
      this.isRunning = isRunning;
   }

   // public boolean start(){
   // return isRunning.compareAndSet(false, true);
   // }

   @Override
   public boolean stop() {
      return isRunning.compareAndSet(true, false);
   }

   @Override
   public boolean isRunning() {
      return isRunning.get();
   }

   @Override
   public long getHash() {
      return hash;
   }

   @Override
   public void setHash(long hash) {
      hashChanged = hash != this.hash;
      this.hash = hash;
   }

   @Override
   public C getConfig() {
      return config;
   }

   @Override
   public void setConfig(C config) {
      this.config = config;
   }

   public Map<BackendChannel, V> getValues() {
      return message.getValues();
   }

   // public void setValues(Map<BackendChannel, V> values) {
   // message.setValues(values);
   // }

   public void init() {
      message = new Message<>();
   }

   public boolean hasValues() {
      return message != null && !message.getValues().isEmpty();
   }

   @Override
   public void add(BackendChannel channel, V value) {
      this.message.add(channel, value);
   }

   @Override
   public Message<C, V> getMessage() {
      message.setConfigChanged(hashChanged);
      hashChanged = false;
      return message;
   }
}
