package ch.psi.daq.queryrest.response.raw.serialize;

import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ch.psi.daq.domain.events.ChannelConfiguration;
import ch.psi.daq.domain.json.BackendChannel;
import ch.psi.daq.queryrest.response.raw.IdProvider;

public interface RawSerializer<C, V> extends IdProvider {
   public static final Logger _LOGGER = LoggerFactory.getLogger(RawSerializer.class);
   public static final ByteOrder DEFAULT_ENCODING = ByteOrder.BIG_ENDIAN;

   ByteBuffer getIdBytes();

   void configure(final C config, final Map<? extends BackendChannel, ChannelConfiguration> channelConfigs);
   
   void serialize(final OutputStream os, final V value) throws RuntimeException;
}
